
import os
import argparse

EXTRA_INFO_SCRIPT = 'tools/balancer-cg/generate_extra_information_from_dataset.py'
INFERENCE_SCRIPT = 'tools/balancer-cg/inference.py'
EXTRA_INFO_OUT_FILE= 'tmp/callgraph_extra_feat.csv'
TMP_FOLDER = "tmp"

#Read command line args
p = argparse.ArgumentParser()
p.add_argument("--output", help="File to output balanced callgraph.")
p.add_argument("--input", help="File output by static analysis")
p.add_argument("--classifier", help="Joblib saved classifier")
p.add_argument("--cutoff", help="Probability cutoff below which edges are removed.")
args = p.parse_args()

#generate extra info
os.system(f'python3 {EXTRA_INFO_SCRIPT} {args.input} {EXTRA_INFO_OUT_FILE}')

#run inference with cutoff value
os.system(f'python3 {INFERENCE_SCRIPT} {EXTRA_INFO_OUT_FILE} {args.classifier} {args.cutoff} > {args.output}')

'''
RAW COMMANDS

python tools/balancer-cg/generate_extra_information_from_dataset.py wala_callgraph.csv cg_with_extra_features.csv
python3 tools/balancer-cg/inference.py ~/cg_with_extra_features.csv ../generate-pruner/wala.joblib 0.6 > pruned_callgraph.csv
'''